package com.example.ejercicio_8_1.Modulo;
import java.io.*;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class Logica {


    private String[][] formato;
    private String[] titulos;


    public Logica() {

    }

    public String[] getTitulos() {
        return titulos;
    }

    public String[][] getFormato() {
        return formato;
    }

    public void cargarDatos()  {
        Persona[]   personas  = new Persona[5];

        titulos = new String[]{"ID", "NOMBRE", "EDAD"};

        personas[0] = new Persona("michael",22);
        personas[1] = new Persona("sanyi",20);
        personas[2] = new Persona("Jhoan",20);
        personas[3] = new Persona("Pepe",20);
        personas[4] = new Persona("bobby",60);

        //Creamos fichero .dat
        try {
            FileOutputStream fileOutputStream = new FileOutputStream("Personas.dat");
            ObjectOutputStream objectOutputStream = new ObjectOutputStream(fileOutputStream);
            objectOutputStream.writeObject(personas);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }

    }


    public void cargarMatrices() {
        //Cojemos el fichero dat y lo convertimos en un objeto
        File fichero = new File("/home/michael/Documents/SpringProjects/Ejercicio_8_1/Personas.dat");
        FileInputStream fileInputStream;
        ObjectInputStream objectInputStream;
        Persona[] personasRecuperadas;
        try {
           //Lee los datos del archivo.
            fileInputStream = new FileInputStream(fichero);
            objectInputStream = new ObjectInputStream(fileInputStream);
            //Recuperamos el archivo
          personasRecuperadas = (Persona[])  objectInputStream.readObject();
            objectInputStream.close();
        } catch (IOException | ClassNotFoundException e) {
            throw  new RuntimeException(e);
        }

        //Printamos por pantalla los datos

        for (Persona persona : personasRecuperadas) {
            System.out.println(persona);
        }

        List<Persona> personas = new ArrayList<>(List.of(personasRecuperadas));

        Persona[][] persona2d = new Persona[personasRecuperadas.length][personasRecuperadas.length];


        //Convertimos nuestro array 1d a un array 2d
        for (int i = 0; i < personasRecuperadas.length ; i++) {
            for (int j = 0; j < personasRecuperadas.length; j++) {
                persona2d[i][j] = personasRecuperadas[i];

            }
        }

        //Convertimos nuestro array 2d en un array 1d para despues insertar valores en nuestra tabla usando los getters.
        for (int i = 0; i < personasRecuperadas.length ; i++) {
            for (int j = 0; j < personasRecuperadas.length; j++) {
                persona2d[0][0] =   persona2d[personas.get(j).getId()][j];
            }
        }

        formato = new String[personasRecuperadas.length][personasRecuperadas.length];

        //Ponemos en nuestra matriz de string los valores deseados de nuestro objeto
        for (int i = 0; i < formato.length ; i++) {
            for (int j = 0; j < formato.length; j++) {
                formato[i][0] = String.valueOf(personas.get(i).getId());
                formato[i][1] = (personas.get(i).getNombre());
                formato[i][2] = String.valueOf((personas.get(i).getEdad()));
            }
        }

        //CREAMOS NUESTRA TABLA

        System.out.println("********************************");

        System.out.println(Arrays.deepToString(persona2d));





    }


}
